task samtools {
    File sam
    String base=basename(sam, ".sam")
    String bam=base + ".bam"
    String sorted_bam=base + ".sorted.bam"
    String sorted_bam_index=base + ".sorted.bam.bai"
    String samstats=base + ".samstats"
    String ins_size=base + ".ins_size"
    String docker
    String cluster
    String disk_size
    Int insert_size

    command <<<
       set -o pipefail
       set -e
       nt=$(nproc)
       /opt/conda/bin/samtools view -@ $nt -bS ${sam} > ${bam}
       /opt/conda/bin/samtools sort -@ $nt -m 2G ${bam} -o ${sorted_bam}
       /opt/conda/bin/samtools index -@ $nt ${sorted_bam}
       /opt/conda/bin/samtools stats -@ $nt ${sorted_bam} > ${samstats}
       /opt/conda/bin/samtools stats -@ $nt -i ${insert_size} ${sorted_bam} |grep ^IS|cut -f 2- > ${ins_size}
    >>>

    runtime {
       docker: docker
       cluster: cluster
       systemDisk: "cloud_ssd 40"
       dataDisk: "cloud_ssd " + disk_size + " /cromwell_root/"
    }

    output {
       File out_sort_bam="${sorted_bam}"
       File out_sort_bam_index="${sorted_bam_index}"
       File out_samstats="${samstats}"
       File out_ins_size="${ins_size}"
    }

}

